package org.netkernel.json.core.endpoint;

import org.json.JSONArray;
import org.json.JSONObject;
import org.netkernel.json.core.rep.DeterminateJSON;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class JSONSerializer extends StandardTransreptorImpl
{

	public JSONSerializer()
	{	this.declareThreadSafe();
		this.declareFromRepresentation(JSONObject.class);
		this.declareFromRepresentation(JSONArray.class);
		this.declareFromRepresentation(DeterminateJSON.class);
		this.declareToRepresentation(String.class);
		this.declareToRepresentation(IReadableBinaryStreamRepresentation.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	Class c=context.getThisRequest().getRepresentationClass();
		Object o=context.sourcePrimary(Object.class);
		if(o instanceof DeterminateJSON)
		{	DeterminateJSON dj=(DeterminateJSON)o;
			if(dj.isArray())
			{	o=dj.getJSONArray();				
			}
			else
			{	o=dj.getJSONObject();
			}
		}
		String s=null;
		if(o instanceof JSONObject)
		{	JSONObject jo=(JSONObject)o;
			s=jo.toString(4);
		}
		else
		{	JSONArray ja=(JSONArray)o;
			s=ja.toString(4);
		}
		Object result=null;
		if(c==String.class)
		{	result=s;
		}
		else
		{	result=new ByteArrayRepresentation(s.getBytes());
		}
		context.createResponseFrom(result);
	}
}
